@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo. Error^^! Please do not execute this file alone^^! && echo. && echo. Please press any key to exit. && pause>nul && exit

:getPartitionTable
    REM vers
    set devicePTFile="%~dp0devicePT_%serial_number%.txt"
    set device_ab_slot=0
    REM remove temp file

    del /f /s /q "%devicePTFile%" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )
    REM is device support A/B partition?
    set device_slot_count=0
    set device_current_slot=
    for /F "usebackq tokens=*" %%X in (`%fastboot% -s %serial_number% getvar slot-count 2^>^&1 ^>nul`) do (
        for /F "tokens=2 delims== " %%C in ('echo %%X ^| %grep% "slot-count:"') do (
            set device_slot_count=%%C
        )
    )
    for /F "usebackq tokens=*" %%X in (`%fastboot% -s %serial_number% getvar current-slot 2^>^&1 ^>nul`) do (
        for /F "tokens=2 delims== " %%C in ('echo %%X ^| %grep% "current-slot:"') do (
            set device_current_slot=%%C
        )
    )

    if "%device_slot_count%" NEQ "" (
        if "!device_slot_count!" EQU "2" (
            set device_ab_slot=1
            echo.
            echo. [Debug] Device [%serial_number%] has slot A/B partition.
        ) else (
            set device_ab_slot=0
            echo.
            echo. [Debug] Device [%serial_number%] does not have slot A/B partition.
        )
    ) else (
        echo.
        echo. [Debug] Device slot info is unknown.
        set device_ab_slot=0
    )

    set slotsuffix=
    if "%device_ab_slot%" EQU "0" (
        set slotsuffix=
    )
    if "%device_ab_slot%" EQU "1" (
        set slotsuffix=_!device_current_slot!
        REM If there are multiple _, use the last two characters
        if "!slotsuffix:~0,2!" EQU "__" (
            set slotsuffix=!slotsuffix:~-2!
        )
        echo. [Debug] Device [!serial_number!] current slot: [!slotsuffix!]
    )

    %fastboot% -s %serial_number% oem partition 2>"%devicePTFile%"

    set cid_tmp=
    set sumposition=0
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "cid:" ^| %awk% "{print $2}" ^| %awk% -F: "{print $1}"') do (
        set cid_tmp=%%C
    )
    if "%cid_tmp%" EQU "lun0" (
        echo. [Debug] Device [%serial_number%] has lun flag.
        set sumposition=3
    ) else (
        echo. [Debug] Device [%serial_number%] does not have lun flag.
        set sumposition=2
    )

    set recovery_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "recovery%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set recovery_a_tmp=%%C
    )
    set dtbo_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "dtbo%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set dtbo_a_tmp=%%C
    )
    set vbmeta_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "vbmeta%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set vbmeta_a_tmp=%%C
    )
    set dsp_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "dsp%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set dsp_a_tmp=%%C
    )
    set bluetooth_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "bluetooth%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set bluetooth_a_tmp=%%C
    )
    set super_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "super:" ^| %awk% "{print $%sumposition%}"') do (
        set super_tmp=%%C
    )
    set system_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "system%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set system_a_tmp=%%C
    )
    set vendor_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "vendor%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set vendor_a_tmp=%%C
    )
    set product_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "product%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set product_a_tmp=%%C
    )
    set oem_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "oem%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set oem_a_tmp=%%C
    )
    set fsg_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "fsg%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set fsg_a_tmp=%%C
    )
    set carrier_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "carrier:" ^| %awk% "{print $%sumposition%}"') do (
        set carrier_tmp=%%C
    )
    set ddr_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "ddr:" ^| %awk% "{print $%sumposition%}"') do (
        set ddr_tmp=%%C
    )
    set oldddr_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "DDR:" ^| %awk% "{print $%sumposition%}"') do (
        set oldddr_tmp=%%C
    )
    set customize_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "customize:" ^| %awk% "{print $%sumposition%}"') do (
        set customize_tmp=%%C
    )
    set clogo_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "clogo:" ^| %awk% "{print $%sumposition%}"') do (
        set clogo_tmp=%%C
    )
    set modemst_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "modemst1:" ^| %awk% "{print $%sumposition%}"') do (
        set modemst_tmp=%%C
    )
    set mdm1m9kefs_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "mdm1m9kefs1:" ^| %awk% "{print $%sumposition%}"') do (
        set mdm1m9kefs_tmp=%%C
    )
    set metadata_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "metadata:" ^| %awk% "{print $%sumposition%}"') do (
        set metadata_tmp=%%C
    )

    REM SLSI related partition
    set ldfw_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "ldfw%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set ldfw_a_tmp=%%C
    )
    set keystorage_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "keystorage%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set keystorage_a_tmp=%%C
    )
    set fwbl1_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "fwbl1:" ^| %awk% "{print $%sumposition%}"') do (
        set fwbl1_tmp=%%C
    )

    REM MTK related partition
    set lk_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "lk%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set lk_a_tmp=%%C
    )
    set tee_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "tee%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set tee_a_tmp=%%C
    )
    set md1img_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "md1img%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set md1img_a_tmp=%%C
    )
    set spmfw_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "spmfw%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set spmfw_a_tmp=%%C
    )
    set scp_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "scp%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set scp_a_tmp=%%C
    )
    set sspm_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "sspm%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set sspm_a_tmp=%%C
    )
    set cam_vpu1_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "cam_vpu1%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set cam_vpu1_a_tmp=%%C
    )
    set dtb_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "dtb%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set dtb_a_tmp=%%C
    )
    set preloader_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "preloader:" ^| %awk% "{print $%sumposition%}"') do (
        set preloader_tmp=%%C
    )
    set nvdata_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "nvdata:" ^| %awk% "{print $%sumposition%}"') do (
        set nvdata_tmp=%%C
    )

    set device_has_recovery=0
    if "%recovery_a_tmp%" EQU "recovery%slotsuffix%:" (
        set device_has_recovery=1
    ) else (
        set device_has_recovery=0
    )
    set device_has_dtbo=0
    if "%dtbo_a_tmp%" EQU "dtbo%slotsuffix%:" (
        set device_has_dtbo=1
    ) else (
        set device_has_dtbo=0
    )
    set device_has_vbmeta=0
    if "%vbmeta_a_tmp%" EQU "vbmeta%slotsuffix%:" (
        set device_has_vbmeta=1
    ) else (
        set device_has_vbmeta=0
    )
    set device_has_dsp=0
    if "%dsp_a_tmp%" EQU "dsp%slotsuffix%:" (
        set device_has_dsp=1
    ) else (
        set device_has_dsp=0
    )
    set device_has_bluetooth=0
    if "%bluetooth_a_tmp%" EQU "bluetooth%slotsuffix%:" (
        set device_has_bluetooth=1
    ) else (
        set device_has_bluetooth=0
    )
    set device_has_super=0
    if "%super_tmp%" EQU "super:" (
        set device_has_super=1
    ) else (
        set device_has_super=0
    )
    set device_has_system=0
    if "%system_a_tmp%" EQU "system%slotsuffix%:" (
        set device_has_system=1
    ) else (
        set device_has_system=0
    )
    set device_has_vendor=0
    if "%vendor_a_tmp%" EQU "vendor%slotsuffix%:" (
        set device_has_vendor=1
    ) else (
        set device_has_vendor=0
    )
    set device_has_product=0
    if "%product_a_tmp%" EQU "product%slotsuffix%:" (
        set device_has_product=1
    ) else (
        set device_has_product=0
    )
    set device_has_oem=0
    if "%oem_a_tmp%" EQU "oem%slotsuffix%:" (
        set device_has_oem=1
    ) else (
        set device_has_oem=0
    )
    set device_has_fsg=0
    if "%fsg_a_tmp%" EQU "fsg%slotsuffix%:" (
        set device_has_fsg=1
    ) else (
        set device_has_fsg=0
    )
    set device_has_carrier=0
    if "%carrier_tmp%" EQU "carrier:" (
        set device_has_carrier=1
    ) else (
        set device_has_carrier=0
    )
    set device_has_ddr=0
    if "%ddr_tmp%" EQU "ddr:" (
        set device_has_ddr=1
    ) else (
        set device_has_ddr=0
    )
    set device_has_oldddr=0
    if "%oldddr_tmp%" EQU "DDR:" (
        set device_has_oldddr=1
    ) else (
        set device_has_oldddr=0
    )
    set device_has_customize=0
    if "%customize_tmp%" EQU "customize:" (
        set device_has_customize=1
    ) else (
        set device_has_customize=0
    )
    set device_has_clogo=0
    if "%clogo_tmp%" EQU "clogo:" (
        set device_has_clogo=1
    ) else (
        set device_has_clogo=0
    )
    set device_has_modemst=0
    if "%modemst_tmp%" EQU "modemst1:" (
        set device_has_modemst=1
    ) else (
        set device_has_modemst=0
    )
    set device_has_mdm1m9kefs=0
    if "%mdm1m9kefs_tmp%" EQU "mdm1m9kefs1:" (
        set device_has_mdm1m9kefs=1
    ) else (
        set device_has_mdm1m9kefs=0
    )
    set device_has_metameta=0
    if "%metadata_tmp%" EQU "metadata:" (
        set device_has_metameta=1
    ) else (
        set device_has_metameta=0
    )
    REM SLSI
    set device_has_ldfw=0
    if "%ldfw_a_tmp%" EQU "ldfw%slotsuffix%:" (
        set device_has_ldfw=1
    ) else (
        set device_has_ldfw=0
    )
    set device_has_keystorage=0
    if "%keystorage_a_tmp%" EQU "keystorage%slotsuffix%:" (
        set device_has_keystorage=1
    ) else (
        set device_has_keystorage=0
    )
    set device_has_fwbl1=0
    if "%fwbl1_tmp%" EQU "fwbl1:" (
        set device_has_fwbl1=1
    ) else (
        set device_has_fwbl1=0
    )
    REM MTK
    set device_has_perloader=0
    if "%preloader_tmp%" EQU "preloader:" (
        set device_has_perloader=1
    ) else (
        set device_has_perloader=0
    )
    set device_has_nvdata=0
    if "%nvdata_tmp%" EQU "nvdata:" (
        set device_has_nvdata=1
    ) else (
        set device_has_nvdata=0
    )
    set device_has_lk=0
    if "%lk_a_tmp%" EQU "lk%slotsuffix%:" (
        set device_has_lk=1
    ) else (
        set device_has_lk=0
    )
    set device_has_tee=0
    if "%tee_a_tmp%" EQU "tee%slotsuffix%:" (
        set device_has_tee=1
    ) else (
        set device_has_tee=0
    )
    set device_has_md1img=0
    if "%md1img_a_tmp%" EQU "md1img%slotsuffix%:" (
        set device_has_md1img=1
    ) else (
        set device_has_md1img=0
    )
    set device_has_spmfw=0
    if "%spmfw_a_tmp%" EQU "spmfw%slotsuffix%:" (
        set device_has_spmfw=1
    ) else (
        set device_has_spmfw=0
    )
    set device_has_scp=0
    if "%scp_a_tmp%" EQU "scp%slotsuffix%:" (
        set device_has_scp=1
    ) else (
        set device_has_scp=0
    )
    set device_has_sspm=0
    if "%sspm_a_tmp%" EQU "sspm%slotsuffix%:" (
        set device_has_sspm=1
    ) else (
        set device_has_sspm=0
    )
    set device_has_cam_vpu1=0
    if "%cam_vpu1_a_tmp%" EQU "cam_vpu1%slotsuffix%:" (
        set device_has_cam_vpu1=1
    ) else (
        set device_has_cam_vpu1=0
    )
    set device_has_dtb=0
    if "%dtb_a_tmp%" EQU "dtb%slotsuffix%:" (
        set device_has_dtb=1
    ) else (
        set device_has_dtb=0
    )

    REM remove temp file
    del /f /s /q "%devicePTFile%" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )
exit /b 0
::
::
:exit
exit
